/* Copyright (c) 1989 by Carrick Sean Casey. All rights reserved. */
/* For copying and distribution information, see the file "copyright.h." */

/* "forum" global variables */

#include "../copyright.h"
#include "../forumnet.h"
#include "../murgil/ipcf.h"
#include "forum.h"

/* non-global definitions */
char packetbuffer[USER_BUF_SIZE];		/* packet buffer */
char messagebuffer[1024];		/* generic large buffer */
char messagebuffer2[256];		/* generic large buffer */

/* global defs */
char *pp = packetbuffer;	/* packet pointer */
char *pbuf = packetbuffer + 1;	/* packet buffer pointer */
char *mbuf = messagebuffer;	/* message buffer */
char *mbuf2 = messagebuffer2;	/* message buffer */
char *myname = 0;		/* nickname of user */
char *mypass = "";		/* password of user */
char *mygroup = "";		/* requested group */
int beeping = 0;		/* 1 if beeping turned on */
char cmdchar = CMDCHAR;		/* default command char */
int connected = 0;		/* 1 when server validates us */
char thishost[132];		/* our hostname */
char continued = 0;		/* did we bg then fg this job? */
int whoflg = 0;			/* just do a who at startup */

/* flags set in .forumrc */
int m_whoheader = 1;	/* who header output */
int m_groupheader = 1;	/* group header output */
int m_nomesg = 0;	/* turn off messages while in forum */
int m_watchtime = 0;	/* using boring time format */

/* commands */
int
	cmd_alert(),
	cmd_noalert(),
	cmd_bug(),
	cmd_ccommand(),
	cmd_message(),
	cmd_list(),
	cmd_help(),
	cmd_help(),
	cmd_log(),
	cmd_nolog(),
	cmd_quit(),
	cmd_shell(),
	cmd_time();

struct Cmd cmds[] = {
/* COMMAND     FUNCTION         DESCRIPTION */
{ "?",       cmd_help,        "?"},
{ "h",       cmd_help,        "h"},
{ "help",    cmd_help,        "help              list help file"},
{ "!",       cmd_shell,       "! [command]       run a command or a shell",},
{ "alert",   cmd_alert,       "alert             make terminal beep on output"},
{ "bug",     cmd_bug,         "bug               send a bug report to sean"},
{ "c",       cmd_list,        "c                 list commands"},
{ "command", cmd_ccommand,    "command [x]       show or set command prefix"},
{ "log",     cmd_log,         "log [filename]    start session logging"},
{ "m",       cmd_message,     0},
{ "noalert", cmd_noalert,     "noalert           turn off \"alert\""},
{ "nolog",   cmd_nolog,       "nolog             end session logging"},
{ "q",       cmd_quit,        "q                 quit",},
{ "t",       cmd_time,        "t                 display the current time",},
{ 0, }
};
